#include <STDAFX.H>
#include "DIWRAPPER.H"

LPDIRECTINPUT		lpDI;
LPDIRECTINPUTDEVICE	lpDIDKeyboard;
LPDIRECTINPUTDEVICE lpDIDJoystick;
LPDIRECTINPUTDEVICE lpDIDMouse;

BOOL CALLBACK KbEnum(LPCDIDEVICEOBJECTINSTANCE lpd, void *lpParam)
{
	char *lpstr = (char*)lpParam;
	memmove(lpstr + (lpd->dwOfs * 256), lpd->tszName, MAX_PATH);
	return DIENUM_CONTINUE;
}

BOOL CALLBACK JsEnum(LPCDIDEVICEINSTANCE lpddi, void *lpParam)
{
	HWND hWnd = *(HWND*)lpParam;
	SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)lpddi->tszProductName);
	SendMessage(hWnd, CB_SETITEMDATA, 0, (LPARAM)&lpddi->guidInstance);
	return DIENUM_CONTINUE;
}

DIWRAPPER::~DIWRAPPER()
{
	if(lpDI != NULL)
	{
		if(lpDIDMouse != NULL)
		{
			lpDIDMouse->Release();
			lpDIDMouse = NULL;
		}
		if(lpDIDKeyboard != NULL)
		{
			lpDIDKeyboard->Release();
			lpDIDKeyboard = NULL;
		}
		lpDI->Release();
		lpDI = NULL;
	}
}

void DIWRAPPER::UpdateKeyboardData()
{
	HRESULT hRet;
	hRet = lpDIDKeyboard->GetDeviceState(256, lpKeyboardData);
	Sleep(20);
	if(hRet == DIERR_INPUTLOST)
	{
		lpDIDKeyboard->Acquire();
		memset(lpKeyboardData, 0, 256);
	}
	if(hRet == DIERR_NOTACQUIRED)
	{
		lpDIDKeyboard->Acquire();
		memset(lpKeyboardData, 0, 256);
	}
}

void DIWRAPPER::UpdateMouseData()
{
	HRESULT hRet;
	hRet = lpDIDMouse->GetDeviceState(sizeof(DIMOUSESTATE), &MouseState);
	if(hRet == DIERR_INPUTLOST)
	{
		lpDIDMouse->Acquire();
		memset(&MouseState, 0, sizeof(DIMOUSESTATE));
	}
	if(hRet == DIERR_NOTACQUIRED)
	{
		lpDIDMouse->Acquire();
		memset(&MouseState, 0, sizeof(DIMOUSESTATE));
	}
}

int DIWRAPPER::Initialize()
{
	DirectInputCreate(GetModuleHandle(NULL), DIRECTINPUT_VERSION, &lpDI, NULL);
	return 1;
}

int DIWRAPPER::InitializeKeyboard(HWND hWnd)
{
	lpDI->CreateDevice(GUID_SysKeyboard, &lpDIDKeyboard, NULL);
	lpDIDKeyboard->SetDataFormat(&c_dfDIKeyboard);
	lpDIDKeyboard->SetCooperativeLevel(hWnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);
	lpDIDKeyboard->Acquire();
	memset(strKeyboardKeys, 0, 65535);
	lpDIDKeyboard->EnumObjects(KbEnum, (void*)strKeyboardKeys, DIDFT_BUTTON);
	return 1;
}

int DIWRAPPER::InitializeMouse(HWND hWnd)
{
	lpDI->CreateDevice(GUID_SysMouse, &lpDIDMouse, NULL);
	lpDIDMouse->SetDataFormat(&c_dfDIMouse);
	lpDIDMouse->SetCooperativeLevel(hWnd, DISCL_EXCLUSIVE | DISCL_FOREGROUND);
	lpDIDMouse->Acquire();
	return 1;
}

int DIWRAPPER::InitializeJoystick(HWND hWnd, GUID *pJoystick)
{
	lpDI->CreateDevice(*pJoystick, &lpDIDJoystick, NULL);
	lpDIDJoystick->SetDataFormat(&c_dfDIJoystick);
	lpDIDJoystick->SetCooperativeLevel(hWnd, DISCL_EXCLUSIVE | DISCL_FOREGROUND);
	lpDIDJoystick->Acquire();
	return 1;
}

void DIWRAPPER::EmumerateJoysticks(HWND hWnd)
{
	lpDI->EnumDevices(DIDEVTYPE_JOYSTICK, JsEnum, (void*)&hWnd, DIEDFL_ALLDEVICES);
}