// Keyboard.cpp : implementation file
//

#include "stdafx.h"
#include "glDuke.h"
#include "Keyboard.h"
#include "Settings.h"
#include "glDukeControls.h"
#include "Keybchng.h"
#include "DIWRAPPER.h"

extern CSettings set;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKeyboard dialog


CKeyboard::CKeyboard(CWnd* pParent /*=NULL*/)
	: CDialog(CKeyboard::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeyboard)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CKeyboard::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyboard)
	DDX_Control(pDX, IDC_KEYS, m_List);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CKeyboard, CDialog)
	//{{AFX_MSG_MAP(CKeyboard)
	ON_NOTIFY(NM_DBLCLK, IDC_KEYS, OnDblclkKeys)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyboard message handlers

int nThKeyboardDone = 0;
int nThKeyboardNew = 0;

UINT ThKeyboard(void *lpParam)
{
	DWORD* dwKey = (DWORD*)lpParam;
	CKeybchng dlg;
	dlg.nFunction = *dwKey;
	dlg.DoModal();
	nThKeyboardNew = dlg.nNew;
	nThKeyboardDone = 1;
	return 0xDEADBEEF;
}

void CKeyboard::UpdateList()
{
	DIWRAPPER di;
	int i = CONTROLCOUNT - 2;
	di.Initialize();
	di.InitializeKeyboard(NULL);
	m_List.DeleteAllItems();
	while(i != -1)
	{
		m_List.InsertItem(0, lpstrControls[i], NULL);
		m_List.SetItemText(0, 1, di.strKeyboardKeys[set.m_Setup.nControls[i]]);
		i--;
	}
	memcpy(m_strKeyboardKeys, di.strKeyboardKeys, 0x10000);
}

BOOL CKeyboard::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
	// TODO: Add extra initialization here
	CRect rc;
	m_List.GetClientRect(&rc);
	m_List.InsertColumn(0, "Function");
	m_List.SetColumnWidth(0, rc.Width() / 2);
	m_List.InsertColumn(1, "Key binding");
	m_List.SetColumnWidth(1, rc.Width() / 2);
	UpdateList();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CKeyboard::OnDblclkKeys(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int nPos;
	nPos = m_List.GetSelectionMark();
	if(nPos != -1)
	{
		nThKeyboardDone = 0;
		AfxBeginThread(ThKeyboard, &nPos);
		while(!nThKeyboardDone)
		{
			UpdateWindow();
			Sleep(100);
		}
		set.m_Setup.nControls[nPos] = nThKeyboardNew;
		m_List.SetItemText(nPos, 1, m_strKeyboardKeys[set.m_Setup.nControls[nPos]]);
		m_List.SetSelectionMark(nPos);
	}
	*pResult = 0;
}
