#include "COMMON.H"

#define PI 3.1415927

__inline int mulscale14(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 14;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale16(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 16;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale20(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 20;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale24(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 24;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale30(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 30;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale6(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 6;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale10(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 10;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale14(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 14;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale15(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 15;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale15(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 15;
		shl eax, 17;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale16(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 16;
		shl eax, 16;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale20(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 12;
		shl eax, 20;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale24(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 8;
		shl eax, 24;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale30(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 2;
		shl eax, 30;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int scale(int a, int b, int c)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov ecx, dword ptr[c];
		imul edx;
		idiv ecx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int klabs(int a)
{
	__asm
	{
		mov eax, dword ptr[a];
		test eax, eax;
		jns skipnegate;
		neg eax;
skipnegate:
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int ksgn(int a)
{
	__asm
	{
		mov ebx, dword ptr[a];
		add ebx, ebx;
		sbb eax, eax;
		cmp eax, ebx;
		adc al, 0;
		mov dword ptr[a], eax;
	}
	return a;
}

struct linetype
{ 
	long x1, y1, x2, y2; 
};

#define MAXCLIPDIST 1024
#define MAXCLIPNUM 512

XBUILD_MAP*			ANIMATE_pMap;
int					ANIMATE_nCurrentSector = -1;
int					ANIMATE_nCurrentSectorChanged = 0;
int					ANIMATE_ClipSectorList[512];
short				ANIMATE_SinTable[2048];
static short		clipnum, hitwalls[4], clipsectnum;
short				editstatus = 0;
static linetype		clipit[MAXCLIPNUM];
static short		clipobjectval[MAXCLIPNUM];
long				clipmoveboxtracenum = 3;
long				hitscangoalx = (1<<29)-1;
long				hitscangoaly = (1<<29)-1;
short				headspritesect[MAXSECTORS+1], headspritestat[MAXSTATUS+1];
short				prevspritesect[MAXSPRITES],	prevspritestat[MAXSPRITES];
short				nextspritesect[MAXSPRITES],	nextspritestat[MAXSPRITES];
extern "C" void		XBUILD_ART_GetTileData(int, XBUILD_ART_TILEDATA*);
extern "C" void*	XBUILD_GFX_GetMapAddress();

int ANIMATE_Inside(long x, long y, short sectnum)
{
	long i, j, x1, y1, x2, y2;
	unsigned long cnt;
	if(sectnum < 0 || sectnum >= ANIMATE_pMap->Mapinfo.SectorNumber) 
	{
		return -1;
	}
	cnt = 0;
	j = ANIMATE_pMap->Sector[sectnum].WallPointer;
	i = ANIMATE_pMap->Sector[sectnum].WallNumber;
	do
	{
		y1 = ANIMATE_pMap->Wall[j].Y - y;
		y2 = ANIMATE_pMap->Wall[ANIMATE_pMap->Wall[j].Point2].Y - y;
		if((y1 ^ y2) < 0)
		{
			x1 = ANIMATE_pMap->Wall[j].X - x; 
			x2 = ANIMATE_pMap->Wall[ANIMATE_pMap->Wall[j].Point2].X - x;
			if ((x1^x2) >= 0) cnt ^= x1; else cnt ^= (x1*y2-x2*y1)^y2;
		}
		j++; i--;
	} while (i);
	return(cnt>>31);
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_GetFloorHeight(short sectnum, long dax, long day)
{
	float dx, dy, i, j, fTemp;
	short nNeg;
	XBUILD_MAP_WALL *wal;
	if(!(ANIMATE_pMap->Sector[sectnum].FStat & 2)) 
	{
		return ANIMATE_pMap->Sector[sectnum].FZ;
	}
	wal = &ANIMATE_pMap->Wall[ANIMATE_pMap->Sector[sectnum].WallPointer];
	dx = (float)(ANIMATE_pMap->Wall[wal->Point2].X - wal->X);
	dy = (float)(ANIMATE_pMap->Wall[wal->Point2].Y - wal->Y);
	i = (float)sqrt((dx * dx) + (dy * dy)) * 4.0f;
	if(i == 0)
	{
		return ANIMATE_pMap->Sector[sectnum].FZ;
	}
	//DMULSCALE10??? It was DMULSCALE3 before...
	j = (float)dmulscale10((int)dx, day - wal->Y, (int)(-dy), dax - wal->X);
	if(ANIMATE_pMap->Sector[sectnum].FHei & 0x8000)
	{
		nNeg = ~(ANIMATE_pMap->Sector[sectnum].FHei & 0x0FFF);
		nNeg &= 0x0FFF;
		nNeg++;
		fTemp = ((float)nNeg * -j) / i;
	}
	else
	{
		fTemp = ((float)ANIMATE_pMap->Sector[sectnum].FHei * j) / i;
	}
	return ANIMATE_pMap->Sector[sectnum].FZ + (int)fTemp;
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_GetCeilingHeight(short sectnum, long dax, long day)
{
	float dx, dy, i, j, fTemp;
	short nNeg;
	XBUILD_MAP_WALL *wal;
	if(!(ANIMATE_pMap->Sector[sectnum].CStat & 2)) 
	{
		return ANIMATE_pMap->Sector[sectnum].CZ;
	}
	wal = &ANIMATE_pMap->Wall[ANIMATE_pMap->Sector[sectnum].WallPointer];
	dx = (float)(ANIMATE_pMap->Wall[wal->Point2].X - wal->X);
	dy = (float)(ANIMATE_pMap->Wall[wal->Point2].Y - wal->Y);
	i = (float)sqrt((dx * dx) + (dy * dy)) * 4.0f;
	if(i == 0)
	{
		return ANIMATE_pMap->Sector[sectnum].CZ;
	}
	j = (float)dmulscale10((int)dx, day - wal->Y, (int)(-dy), dax - wal->X);
	if(ANIMATE_pMap->Sector[sectnum].CHei & 0x8000)
	{
		nNeg = ~(ANIMATE_pMap->Sector[sectnum].CHei & 0x0FFF);
		nNeg &= 0x0FFF;
		nNeg++;
		fTemp = ((float)nNeg * -j) / i;
	}
	else
	{
		fTemp = ((float)ANIMATE_pMap->Sector[sectnum].CHei * j) / i;
	}
	return ANIMATE_pMap->Sector[sectnum].CZ + (int)fTemp;
}

int rintersect(long x1, long y1, long z1, long vx, long vy, long vz, long x3, long y3, long x4, long y4, long *intx, long *inty, long *intz)
{     //p1 towards p2 is a ray
	long x34, y34, x31, y31, bot, topt, topu, t;

	x34 = x3-x4; y34 = y3-y4;
	bot = vx*y34 - vy*x34;
	if (bot >= 0)
	{
		if (bot == 0) return(0);
		x31 = x3-x1; y31 = y3-y1;
		topt = x31*y34 - y31*x34; if (topt < 0) return(0);
		topu = vx*y31 - vy*x31; if ((topu < 0) || (topu >= bot)) return(0);
	}
	else
	{
		x31 = x3-x1; y31 = y3-y1;
		topt = x31*y34 - y31*x34; if (topt > 0) return(0);
		topu = vx*y31 - vy*x31; if ((topu > 0) || (topu <= bot)) return(0);
	}
	t = divscale16(topt,bot);
	*intx = x1 + mulscale16(vx,t);
	*inty = y1 + mulscale16(vy,t);
	*intz = z1 + mulscale16(vz,t);
	return(1);
}

extern "C" void DLLEXPORT XBUILD_ANIMATE_UpdateSector(long x, long y, int *sectnum)
{
	long i, j, k;

	if(ANIMATE_Inside(x,y,*sectnum) == 1) return;

	if ((*sectnum >= 0) && (*sectnum < ANIMATE_pMap->Mapinfo.SectorNumber))
	{
		k = ANIMATE_pMap->Sector[*sectnum].WallPointer;
		j = ANIMATE_pMap->Sector[*sectnum].WallNumber;
		do
		{
			i = ANIMATE_pMap->Wall[k].NextSector;
			if (i >= 0)
				if (ANIMATE_Inside(x,y,(short)i) == 1)
				{
					*sectnum = i;
					return;
				}
			k++;
			j--;
		} while (j != 0);
	}

	for(i=ANIMATE_pMap->Mapinfo.SectorNumber-1;i>=0;i--)
		if (ANIMATE_Inside(x,y,(short)i) == 1)
		{
			*sectnum = i;
			return;
		}

	*sectnum = -1;
}

int ANIMATE_lintersect(long x1, long y1, long z1, long x2, long y2, long z2, long x3,
			  long y3, long x4, long y4, long *intx, long *inty, long *intz)
{     //p1 to p2 is a line segment
	long x21, y21, x34, y34, x31, y31, bot, topt, topu, t;

	x21 = x2-x1; x34 = x3-x4;
	y21 = y2-y1; y34 = y3-y4;
	bot = x21*y34 - y21*x34;
	if (bot >= 0)
	{
		if (bot == 0) return(0);
		x31 = x3-x1; y31 = y3-y1;
		topt = x31*y34 - y31*x34; if ((topt < 0) || (topt >= bot)) return(0);
		topu = x21*y31 - y21*x31; if ((topu < 0) || (topu >= bot)) return(0);
	}
	else
	{
		x31 = x3-x1; y31 = y3-y1;
		topt = x31*y34 - y31*x34; if ((topt > 0) || (topt <= bot)) return(0);
		topu = x21*y31 - y21*x31; if ((topu > 0) || (topu <= bot)) return(0);
	}
	t = divscale24(topt,bot);
	*intx = x1 + mulscale24(x21,t);
	*inty = y1 + mulscale24(y21,t);
	*intz = z1 + mulscale24(z2-z1,t);
	return(1);
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_HitScan(long xs, long ys, long zs, short sectnum, long vx, long vy, long vz, short *hitsect, short *hitwall, short *hitsprite, long *hitx, long *hity, long *hitz, unsigned long cliptype)
{
	XBUILD_MAP_SECTOR *sec;
	XBUILD_MAP_WALL *wal, *wal2;
	XBUILD_MAP_SPRITE *spr;
	long z, zz, x1, y1, z1, x2, y2, z2, x3, y3, x4, y4, intx, inty, intz;
	long topt, topu, bot, dist, offx, offy, cstat;
	long i, j, k, l, tilenum, xoff, yoff, dax, day, daz, daz2;
	long ang, cosang, sinang, xspan, yspan, xrepeat, yrepeat;
	long dawalclipmask, dasprclipmask;
	short tempshortcnt, tempshortnum, dasector, startwall, endwall;
	short nextsector;
	char clipyou;

	*hitsect = -1; *hitwall = -1; *hitsprite = -1;
	if (sectnum < 0) return(-1);

	*hitx = hitscangoalx; *hity = hitscangoaly;

	dawalclipmask = (cliptype&65535);
	dasprclipmask = (cliptype>>16);

	ANIMATE_ClipSectorList[0] = sectnum;
	tempshortcnt = 0; tempshortnum = 1;
	do
	{
		dasector = ANIMATE_ClipSectorList[tempshortcnt]; sec = &ANIMATE_pMap->Sector[dasector];

		x1 = 0x7fffffff;
		if (sec->CStat&2)
		{
			wal = &ANIMATE_pMap->Wall[sec->WallPointer]; wal2 = &ANIMATE_pMap->Wall[wal->Point2];
			dax = wal2->X-wal->X; day = wal2->Y-wal->Y;
			i = (int)sqrt((double)(dax*dax+day*day));
			//i = nsqrtasm(dax*dax+day*day); if (i == 0) continue;
			i = divscale15(sec->CHei,i);
			dax *= i; day *= i;

			j = (vz<<8)-dmulscale15(dax,vy,-day,vx);
			if (j != 0)
			{
				i = (((sec->CZ << 4)-zs)<<8)+dmulscale15(dax,ys-wal->Y,-day,xs-wal->X);
				if (((i^j) >= 0) && ((klabs(i)>>1) < klabs(j)))
				{
					i = divscale30(i,j);
					x1 = xs + mulscale30(vx,i);
					y1 = ys + mulscale30(vy,i);
					z1 = zs + mulscale30(vz,i);
				}
			}
		}
		else if ((vz < 0) && (zs >= (sec->CZ << 4)))
		{
			z1 = (sec->CZ << 4); i = z1-zs;
			if ((klabs(i)>>1) < -vz)
			{
				i = divscale30(i,vz);
				x1 = xs + mulscale30(vx,i);
				y1 = ys + mulscale30(vy,i);
			}
		}
		if ((x1 != 0x7fffffff) && (klabs(x1-xs)+klabs(y1-ys) < klabs((*hitx)-xs)+klabs((*hity)-ys)))
			if (ANIMATE_Inside(x1,y1,dasector) != 0)
			{
				*hitsect = dasector; *hitwall = -1; *hitsprite = -1;
				*hitx = x1; *hity = y1; *hitz = z1;
			}

		x1 = 0x7fffffff;
		if (sec->FStat&2)
		{
			wal = &ANIMATE_pMap->Wall[sec->WallPointer]; wal2 = &ANIMATE_pMap->Wall[wal->Point2];
			dax = wal2->X-wal->X; day = wal2->Y-wal->Y;
			//i = nsqrtasm(dax*dax+day*day); if (i == 0) continue;
			i = (int)sqrt((double)(dax*dax+day*day));
			i = divscale15(sec->FHei,i);
			dax *= i; day *= i;

			j = (vz<<8)-dmulscale15(dax,vy,-day,vx);
			if (j != 0)
			{
				i = (((sec->FZ << 4)-zs)<<8)+dmulscale15(dax,ys-wal->Y,-day,xs-wal->X);
				if (((i^j) >= 0) && ((klabs(i)>>1) < klabs(j)))
				{
					i = divscale30(i,j);
					x1 = xs + mulscale30(vx,i);
					y1 = ys + mulscale30(vy,i);
					z1 = zs + mulscale30(vz,i);
				}
			}
		}
		else if ((vz > 0) && (zs <= (sec->FZ << 4)))
		{
			z1 = (sec->FZ << 4); i = z1-zs;
			if ((klabs(i)>>1) < vz)
			{
				i = divscale30(i,vz);
				x1 = xs + mulscale30(vx,i);
				y1 = ys + mulscale30(vy,i);
			}
		}
		if ((x1 != 0x7fffffff) && (klabs(x1-xs)+klabs(y1-ys) < klabs((*hitx)-xs)+klabs((*hity)-ys)))
			if (ANIMATE_Inside(x1,y1,dasector) != 0)
			{
				*hitsect = dasector; *hitwall = -1; *hitsprite = -1;
				*hitx = x1; *hity = y1; *hitz = z1;
			}

		startwall = sec->WallPointer; endwall = startwall + sec->WallNumber;
		for(z=startwall,wal=&ANIMATE_pMap->Wall[startwall];z<endwall;z++,wal++)
		{
			wal2 = &ANIMATE_pMap->Wall[wal->Point2];
			x1 = wal->X; y1 = wal->Y; x2 = wal2->X; y2 = wal2->Y;

			if ((x1-xs)*(y2-ys) < (x2-xs)*(y1-ys)) continue;
			if (rintersect(xs,ys,zs,vx,vy,vz,x1,y1,x2,y2,&intx,&inty,&intz) == 0) continue;

			if (klabs(intx-xs)+klabs(inty-ys) >= klabs((*hitx)-xs)+klabs((*hity)-ys)) continue;

			nextsector = wal->NextSector;
			if ((nextsector < 0) || (wal->CStat&dawalclipmask))
			{
				*hitsect = dasector; *hitwall = (short)z; *hitsprite = -1;
				*hitx = intx; *hity = inty; *hitz = intz;
				continue;
			}
			daz = XBUILD_ANIMATE_GetCeilingHeight(nextsector, intx, inty) << 4;
			daz2 = XBUILD_ANIMATE_GetFloorHeight(nextsector, intx, inty) << 4;
			//getzsofslope(nextsector,intx,inty,&daz,&daz2);
			if ((intz <= daz) || (intz >= daz2))
			{
				*hitsect = dasector; *hitwall = (short)z; *hitsprite = -1;
				*hitx = intx; *hity = inty; *hitz = intz;
				continue;
			}

			for(zz=tempshortnum-1;zz>=0;zz--)
				if (ANIMATE_ClipSectorList[zz] == nextsector) break;
			if (zz < 0) ANIMATE_ClipSectorList[tempshortnum++] = nextsector;
		}

		/*for(z=headspritesect[dasector];z>=0;z=nextspritesect[z])
		{
			spr = &sprite[z];
			cstat = spr->cstat;
			if ((cstat&dasprclipmask) == 0) continue;

			x1 = spr->x; y1 = spr->y; z1 = spr->z;
			switch(cstat&48)
			{
				case 0:
					topt = vx*(x1-xs) + vy*(y1-ys); if (topt <= 0) continue;
					bot = vx*vx + vy*vy; if (bot == 0) continue;

					intz = zs+scale(vz,topt,bot);

					i = (tilesizy[spr->picnum]*spr->yrepeat<<2);
					if (cstat&128) z1 += (i>>1);
					if (picanm[spr->picnum]&0x00ff0000) z1 -= ((long)((signed char)((picanm[spr->picnum]>>16)&255))*spr->yrepeat<<2);
					if ((intz > z1) || (intz < z1-i)) continue;
					topu = vx*(y1-ys) - vy*(x1-xs);

					offx = scale(vx,topu,bot);
					offy = scale(vy,topu,bot);
					dist = offx*offx + offy*offy;
					i = tilesizx[spr->picnum]*spr->xrepeat; i *= i;
					if (dist > (i>>7)) continue;
					intx = xs + scale(vx,topt,bot);
					inty = ys + scale(vy,topt,bot);

					if (klabs(intx-xs)+klabs(inty-ys) > klabs((*hitx)-xs)+klabs((*hity)-ys)) continue;

					*hitsect = dasector; *hitwall = -1; *hitsprite = z;
					*hitx = intx; *hity = inty; *hitz = intz;
					break;
				case 16:
						//These lines get the 2 points of the rotated sprite
						//Given: (x1, y1) starts out as the center point
					tilenum = spr->picnum;
					xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
					if ((cstat&4) > 0) xoff = -xoff;
					k = spr->ang; l = spr->xrepeat;
					dax = sintable[k&2047]*l; day = sintable[(k+1536)&2047]*l;
					l = tilesizx[tilenum]; k = (l>>1)+xoff;
					x1 -= mulscale16(dax,k); x2 = x1+mulscale16(dax,l);
					y1 -= mulscale16(day,k); y2 = y1+mulscale16(day,l);

					if ((cstat&64) != 0)   //back side of 1-way sprite
						if ((x1-xs)*(y2-ys) < (x2-xs)*(y1-ys)) continue;

					if (rintersect(xs,ys,zs,vx,vy,vz,x1,y1,x2,y2,&intx,&inty,&intz) == 0) continue;

					if (klabs(intx-xs)+klabs(inty-ys) > klabs((*hitx)-xs)+klabs((*hity)-ys)) continue;

					k = ((tilesizy[spr->picnum]*spr->yrepeat)<<2);
					if (cstat&128) daz = spr->z+(k>>1); else daz = spr->z;
					if (picanm[spr->picnum]&0x00ff0000) daz -= ((long)((signed char)((picanm[spr->picnum]>>16)&255))*spr->yrepeat<<2);
					if ((intz < daz) && (intz > daz-k))
					{
						*hitsect = dasector; *hitwall = -1; *hitsprite = z;
						*hitx = intx; *hity = inty; *hitz = intz;
					}
					break;
				case 32:
					if (vz == 0) continue;
					intz = z1;
					if (((intz-zs)^vz) < 0) continue;
					if ((cstat&64) != 0)
						if ((zs > intz) == ((cstat&8)==0)) continue;

					intx = xs+scale(intz-zs,vx,vz);
					inty = ys+scale(intz-zs,vy,vz);

					if (klabs(intx-xs)+klabs(inty-ys) > klabs((*hitx)-xs)+klabs((*hity)-ys)) continue;

					tilenum = spr->picnum;
					xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
					yoff = (long)((signed char)((picanm[tilenum]>>16)&255))+((long)spr->yoffset);
					if ((cstat&4) > 0) xoff = -xoff;
					if ((cstat&8) > 0) yoff = -yoff;

					ang = spr->ang;
					cosang = sintable[(ang+512)&2047]; sinang = sintable[ang];
					xspan = tilesizx[tilenum]; xrepeat = spr->xrepeat;
					yspan = tilesizy[tilenum]; yrepeat = spr->yrepeat;

					dax = ((xspan>>1)+xoff)*xrepeat; day = ((yspan>>1)+yoff)*yrepeat;
					x1 += dmulscale16(sinang,dax,cosang,day)-intx;
					y1 += dmulscale16(sinang,day,-cosang,dax)-inty;
					l = xspan*xrepeat;
					x2 = x1 - mulscale16(sinang,l);
					y2 = y1 + mulscale16(cosang,l);
					l = yspan*yrepeat;
					k = -mulscale16(cosang,l); x3 = x2+k; x4 = x1+k;
					k = -mulscale16(sinang,l); y3 = y2+k; y4 = y1+k;

					clipyou = 0;
					if ((y1^y2) < 0)
					{
						if ((x1^x2) < 0) clipyou ^= (x1*y2<x2*y1)^(y1<y2);
						else if (x1 >= 0) clipyou ^= 1;
					}
					if ((y2^y3) < 0)
					{
						if ((x2^x3) < 0) clipyou ^= (x2*y3<x3*y2)^(y2<y3);
						else if (x2 >= 0) clipyou ^= 1;
					}
					if ((y3^y4) < 0)
					{
						if ((x3^x4) < 0) clipyou ^= (x3*y4<x4*y3)^(y3<y4);
						else if (x3 >= 0) clipyou ^= 1;
					}
					if ((y4^y1) < 0)
					{
						if ((x4^x1) < 0) clipyou ^= (x4*y1<x1*y4)^(y4<y1);
						else if (x4 >= 0) clipyou ^= 1;
					}

					if (clipyou != 0)
					{
						*hitsect = dasector; *hitwall = -1; *hitsprite = z;
						*hitx = intx; *hity = inty; *hitz = intz;
					}
					break;
			}
		}*/
		tempshortcnt++;
	} while (tempshortcnt < tempshortnum);
	return(0);
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_NearTag(long xs, long ys, long zs, short sectnum, short ange, short *neartagsector, short *neartagwall, short *neartagsprite, long *neartaghitdist, long neartagrange, char tagsearch)
{
	XBUILD_MAP_WALL *wal, *wal2;
	XBUILD_MAP_SPRITE *spr;
	XBUILD_ART_TILEDATA t;
	long i, z, zz, xe, ye, ze, x1, y1, z1, x2, y2, z2, intx, inty, intz;
	long topt, topu, bot, dist, offx, offy, vx, vy, vz;
	short tempshortcnt, tempshortnum, dasector, startwall, endwall;
	short nextsector, good;

	*neartagsector = -1; *neartagwall = -1; *neartagsprite = -1;
	*neartaghitdist = 0;

	if (sectnum < 0) return(0);
	if ((tagsearch < 1) || (tagsearch > 3)) return(0);

	vx = mulscale14(ANIMATE_SinTable[(ange+2560)&2047],neartagrange); xe = xs+vx;
	vy = mulscale14(ANIMATE_SinTable[(ange+2048)&2047],neartagrange); ye = ys+vy;
	vz = 0; ze = 0;

	ANIMATE_ClipSectorList[0] = sectnum;
	tempshortcnt = 0; tempshortnum = 1;

	do
	{
		dasector = ANIMATE_ClipSectorList[tempshortcnt];

		startwall = ANIMATE_pMap->Sector[dasector].WallPointer;
		endwall = startwall + ANIMATE_pMap->Sector[dasector].WallNumber - 1;
		for(z=startwall,wal=&ANIMATE_pMap->Wall[startwall];z<=endwall;z++,wal++)
		{
			wal2 = &ANIMATE_pMap->Wall[wal->Point2];
			x1 = wal->X; y1 = wal->Y; x2 = wal2->X; y2 = wal2->Y;

			nextsector = wal->NextSector;

			good = 0;
			if (nextsector >= 0)
			{
				if ((tagsearch&1) && ANIMATE_pMap->Sector[nextsector].LoTag) good |= 1;
				if ((tagsearch&2) && ANIMATE_pMap->Sector[nextsector].HiTag) good |= 1;
			}
			if ((tagsearch&1) && wal->LoTag) good |= 2;
			if ((tagsearch&2) && wal->HiTag) good |= 2;

			if ((good == 0) && (nextsector < 0)) continue;
			if ((x1-xs)*(y2-ys) < (x2-xs)*(y1-ys)) continue;

			if (ANIMATE_lintersect(xs,ys,zs,xe,ye,ze,x1,y1,x2,y2,&intx,&inty,&intz) == 1)
			{
				if (good != 0)
				{
					if (good&1) *neartagsector = nextsector;
					if (good&2) *neartagwall = z;
					*neartaghitdist = dmulscale14(intx-xs,ANIMATE_SinTable[(ange+2560)&2047],inty-ys,ANIMATE_SinTable[(ange+2048)&2047]);
					xe = intx; ye = inty; ze = intz;
				}
				if (nextsector >= 0)
				{
					for(zz=tempshortnum-1;zz>=0;zz--)
						if (ANIMATE_ClipSectorList[zz] == nextsector) break;
					if (zz < 0) ANIMATE_ClipSectorList[tempshortnum++] = nextsector;
				}
			}
		}

		for(z = 0;z < ANIMATE_pMap->Mapinfo.SpriteNumber;z++)
		{
			spr = &ANIMATE_pMap->Sprite[z];
			if(spr->SectorNum != sectnum) continue;
			good = 0;
			if ((tagsearch&1) && spr->LoTag) good |= 1;
			if ((tagsearch&2) && spr->HiTag) good |= 1;
			if (good != 0)
			{
				x1 = spr->X; y1 = spr->Y; z1 = spr->Z << 4;
				XBUILD_ART_GetTileData(spr->Pic, &t);
				topt = vx*(x1-xs) + vy*(y1-ys);
				if (topt > 0)
				{
					bot = vx*vx + vy*vy;
					if (bot != 0)
					{
						intz = zs+scale(vz,topt,bot);
						i = t.Height*spr->RepY;
						if (spr->CStat&128) z1 += (i<<1);
						//if (picanm[spr->picnum]&0x00ff0000) z1 -= ((long)((signed char)((picanm[spr->picnum]>>16)&255))*spr->yrepeat<<2);
						if ((intz <= z1) && (intz >= z1-(i<<2)))
						{
							topu = vx*(y1-ys) - vy*(x1-xs);

							offx = scale(vx,topu,bot);
							offy = scale(vy,topu,bot);
							dist = offx*offx + offy*offy;
							i = (t.Width*spr->RepX); i *= i;
							if (dist <= (i>>7))
							{
								intx = xs + scale(vx,topt,bot);
								inty = ys + scale(vy,topt,bot);
								if (klabs(intx-xs)+klabs(inty-ys) < klabs(xe-xs)+klabs(ye-ys))
								{
									*neartagsprite = z;
									*neartaghitdist = dmulscale14(intx-xs,ANIMATE_SinTable[(ange+2560)&2047],inty-ys,ANIMATE_SinTable[(ange+2048)&2047]);
									xe = intx;
									ye = inty;
									ze = intz;
								}
							}
						}
					}
				}
			}
		}
		tempshortcnt++;
	} while (tempshortcnt < tempshortnum);
	return 0;
}

extern "C" void DLLEXPORT XBUILD_ANIMATE_ChangeCurrentSector(int nNewSector)
{
	ANIMATE_nCurrentSector = nNewSector;
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_HasCurrentSectorChanged()
{
	return ANIMATE_nCurrentSectorChanged;
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_GetCurrentSector()
{
	return ANIMATE_nCurrentSector;
}

int ANIMATE_IsPointNearWall(long x, long y, int nWallNum, long nWallDist)
{
	long x1, y1, x2, y2, r;
	r = (nWallDist<<1);
	
	x1 = ANIMATE_pMap->Wall[nWallNum].X + nWallDist - x; 
	y1 = ANIMATE_pMap->Wall[nWallNum].Y + nWallDist - y;
	x2 = ANIMATE_pMap->Wall[ANIMATE_pMap->Wall[nWallNum].Point2].X + nWallDist - x; 
	y2 = ANIMATE_pMap->Wall[ANIMATE_pMap->Wall[nWallNum].Point2].Y + nWallDist - y;

	if ((x1 < 0) && (x2 < 0)) return(0);
	if ((y1 < 0) && (y2 < 0)) return(0);
	if ((x1 >= r) && (x2 >= r)) return(0);
	if ((y1 >= r) && (y2 >= r)) return(0);

	x2 -= x1; y2 -= y1;
	if (x2*(nWallDist-y1) >= y2*(nWallDist-x1))  //Front
	{
		if (x2 > 0) x2 *= (0-y1); else x2 *= (r-y1);
		if (y2 > 0) y2 *= (r-x1); else y2 *= (0-x1);
		return(x2 < y2);
	}
	if (x2 > 0) x2 *= (r-y1); else x2 *= (0-y1);
	if (y2 > 0) y2 *= (0-x1); else y2 *= (r-x1);
	return((x2 >= y2)<<1);
}

extern "C" BOOL DLLEXPORT XBUILD_ANIMATE_IsPositionValid(int X, int Y, int nOldZ, int nStepHeight)
{
	int a, i, k;
	int t;
	a = ANIMATE_nCurrentSector;
	XBUILD_ANIMATE_UpdateSector(X, Y, &a);
	if(a == -1)
	{
		return FALSE;
	}
	k = ANIMATE_pMap->Sector[a].WallPointer;
	for(i = 0; i < ANIMATE_pMap->Sector[a].WallNumber; i++)
	{
		if(ANIMATE_pMap->Wall[k].NextSector == 0xFFFF || ANIMATE_pMap->Wall[k].CStat & 0x0041)
		{
			if(a == ANIMATE_nCurrentSector)
			{
				t = ANIMATE_IsPointNearWall(X, Y, k, 150);
				if(t != 0)
				{
					return FALSE;
				}
			}
		}
		k = ANIMATE_pMap->Wall[k].Point2;
	}
	if(((nOldZ + 500) - (XBUILD_ANIMATE_GetFloorHeight(a, X, Y))) > nStepHeight)
	{
		return FALSE;
	}
	if(nOldZ < ANIMATE_pMap->Sector[a].CZ)
	{
		return FALSE;
	}
	return TRUE;
}

extern "C" void DLLEXPORT XBUILD_ANIMATE_SetCurrentPosition(int nX, int nY, int nZ)
{
	int a = ANIMATE_nCurrentSector;
	XBUILD_ANIMATE_UpdateSector(nX, nY, &a);
	//Fix for "ClipMove" problems
	if(XBUILD_ANIMATE_GetCeilingHeight(a, nX, nY) > nZ)
	{
		a = ANIMATE_nCurrentSector;
	}
	if(XBUILD_ANIMATE_GetFloorHeight(a, nX, nY) < nZ)
	{
		a = ANIMATE_nCurrentSector;
	}
	if(a != ANIMATE_nCurrentSector)
	{
		ANIMATE_nCurrentSectorChanged = 1;
	}
	else
	{
		ANIMATE_nCurrentSectorChanged = 0;
	}
	ANIMATE_nCurrentSector = a;
}

int ANIMATE_InsertSpriteSector(short sectnum)
{
	short blanktouse;

	if ((sectnum >= MAXSECTORS) || (headspritesect[MAXSECTORS] == -1))
		return -1;

	blanktouse = headspritesect[MAXSECTORS];

	headspritesect[MAXSECTORS] = nextspritesect[blanktouse];
	if (headspritesect[MAXSECTORS] >= 0)
		prevspritesect[headspritesect[MAXSECTORS]] = -1;

	prevspritesect[blanktouse] = -1;
	nextspritesect[blanktouse] = headspritesect[sectnum];
	if (headspritesect[sectnum] >= 0)
		prevspritesect[headspritesect[sectnum]] = blanktouse;
	headspritesect[sectnum] = blanktouse;

	ANIMATE_pMap->Sprite[blanktouse].SectorNum = sectnum;

	return(blanktouse);
}

void ANIMATE_InitializeSpriteList()
{
	long i;
	for (i=0;i<MAXSECTORS;i++)
	{
		headspritesect[i] = -1;
	}
	headspritesect[MAXSECTORS] = 0;
	for(i = 0; i < MAXSPRITES; i++)
	{
		prevspritesect[i] = i-1;
		nextspritesect[i] = i+1;
	}
	prevspritesect[0] = -1;
	nextspritesect[MAXSPRITES-1] = -1;
	for(i = 0; i < ANIMATE_pMap->Mapinfo.SpriteNumber; i++)
	{
		ANIMATE_InsertSpriteSector(ANIMATE_pMap->Sprite[i].SectorNum);
	}
}

extern "C" void DLLEXPORT XBUILD_ANIMATE_Initialize()
{
	DWORD dwSize;
	unsigned _int8 *lpData;
	XBUILD_GRPMANAGER_GetFileData("TABLES.DAT", &lpData, (unsigned _int32*)&dwSize);
	memcpy(ANIMATE_SinTable, lpData, 2048 * 2);
	ANIMATE_pMap = (XBUILD_MAP*)XBUILD_GFX_GetMapAddress();
	ANIMATE_InitializeSpriteList();
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_GetTileIncrement(XBUILD_ART_TILEDATA *p)
{
	int nTimerCount = 0;
	int i, k, offs;
	nTimerCount = GetTickCount() / 18;
	offs = 0;
	i = (nTimerCount >> ((p->Attributes >> 24) & 15));
	if(p->Attributes & 0x3F)
	{
		switch(p->Attributes & 0xC0)
		{
		case 0x40:
			k = (i % ((p->Attributes & 0x3F) << 1));
			if(k < (p->Attributes & 0x3F))
			{
				offs = k;
			}
			else
			{
				offs = (((p->Attributes & 0x3F) << 1) - k);
			}
			break;
		case 0x80:
			offs = (i % ((p->Attributes & 0x3F) + 1));
			break;
		case 0xC0:
			offs = -((i % ((p->Attributes & 0x3F) + 1)));
			break;
		}
	}
	return offs;
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_LookForSpriteInSector(int nSector, int nSpritePic, int nLoTag)
{
	int i;
	for(i = 0; i < ANIMATE_pMap->Mapinfo.SpriteNumber; i++)
	{
		if(ANIMATE_pMap->Sprite[i].SectorNum == nSector)
		{
			if(ANIMATE_pMap->Sprite[i].Pic == nSpritePic)
			{
				if(nLoTag == -1)
				{
					return i;
				}
				if(ANIMATE_pMap->Sprite[i].LoTag == nLoTag)
				{
					return i;
				}
			}
		}
	}
	return -1;
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_LookForSpriteWithSameTag(int nLoTag, int nHiTag, int nSprite)
{
	int i;
	for(i = 0; i < ANIMATE_pMap->Mapinfo.SpriteNumber; i++)
	{
		if(ANIMATE_pMap->Sprite[i].LoTag == nLoTag)
		{
			if(ANIMATE_pMap->Sprite[i].HiTag == nHiTag)
			{
				if(i != nSprite)
				{
					return i;
				}
			}
		}
	}
	return -1;
}

extern "C" float DLLEXPORT XBUILD_ANIMATE_BuildToDegree(int nBuild)
{
	return ((1.0f - ((float)nBuild / 2048.0f)) * 360.0f) - 90.0f;
}

extern "C" float DLLEXPORT XBUILD_ANIMATE_BuildToRadians(int nBuild)
{
	return ((1.0f - ((float)nBuild / 2048.0f)) * 2 * PI) - (PI / 2);
}

__inline void addclipline(int dax1, int day1, int dax2, int day2, int daoval)
{                                                        
	clipit[clipnum].x1 = dax1; clipit[clipnum].y1 = day1; 
	clipit[clipnum].x2 = dax2; clipit[clipnum].y2 = day2; 
	clipobjectval[clipnum] = daoval;                      
	clipnum++;                                            
}                                                        

int raytrace (long x3, long y3, long *x4, long *y4)
{
	long x1, y1, x2, y2, t, bot, topu, nintx, ninty, cnt, z, hitwall;
	long x21, y21, x43, y43;

	hitwall = -1;
	for(z=clipnum-1;z>=0;z--)
	{
		x1 = clipit[z].x1; x2 = clipit[z].x2; x21 = x2-x1;
		y1 = clipit[z].y1; y2 = clipit[z].y2; y21 = y2-y1;

		topu = x21*(y3-y1) - (x3-x1)*y21; if (topu <= 0) continue;
		if (x21*(*y4-y1) > (*x4-x1)*y21) continue;
		x43 = *x4-x3; y43 = *y4-y3;
		if (x43*(y1-y3) > (x1-x3)*y43) continue;
		if (x43*(y2-y3) <= (x2-x3)*y43) continue;
		bot = x43*y21 - x21*y43; if (bot == 0) continue;

		cnt = 256;
		do
		{
			cnt--; if (cnt < 0) { *x4 = x3; *y4 = y3; return(z); }
			nintx = x3 + scale(x43,topu,bot);
			ninty = y3 + scale(y43,topu,bot);
			topu--;
		} while (x21*(ninty-y1) <= (nintx-x1)*y21);

		if (klabs(x3-nintx)+klabs(y3-ninty) < klabs(x3-*x4)+klabs(y3-*y4))
			{ *x4 = nintx; *y4 = ninty; hitwall = z; }
	}
	return(hitwall);
}

void keepaway (long *x, long *y, long w)
{
	long dx, dy, ox, oy, x1, y1;
	char first;

	x1 = clipit[w].x1; dx = clipit[w].x2-x1;
	y1 = clipit[w].y1; dy = clipit[w].y2-y1;
	ox = ksgn(-dy); oy = ksgn(dx);
	first = (klabs(dx) <= klabs(dy));
	while (1)
	{
		if (dx*(*y-y1) > (*x-x1)*dy) return;
		if (first == 0) *x += ox; else *y += oy;
		first ^= 1;
	}
}

int clipinsideboxline(long x, long y, long x1, long y1, long x2, long y2, long walldist)
{
	long r;

	r = (walldist<<1);

	x1 += walldist-x; x2 += walldist-x;
	if ((x1 < 0) && (x2 < 0)) return(0);
	if ((x1 >= r) && (x2 >= r)) return(0);

	y1 += walldist-y; y2 += walldist-y;
	if ((y1 < 0) && (y2 < 0)) return(0);
	if ((y1 >= r) && (y2 >= r)) return(0);

	x2 -= x1; y2 -= y1;
	if (x2*(walldist-y1) >= y2*(walldist-x1))  //Front
	{
		if (x2 > 0) x2 *= (0-y1); else x2 *= (r-y1);
		if (y2 > 0) y2 *= (r-x1); else y2 *= (0-x1);
		return(x2 < y2);
	}
	if (x2 > 0) x2 *= (r-y1); else x2 *= (0-y1);
	if (y2 > 0) y2 *= (0-x1); else y2 *= (r-x1);
	return((x2 >= y2)<<1);
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_GetValueFromSinTable(int Angle)
{
	return (int)ANIMATE_SinTable[Angle & 2047];
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_ClipMove(long *x, long *y, long *z, short *sectnum, long xvect, long yvect, long walldist, long ceildist, long flordist, unsigned long cliptype)
{
	XBUILD_MAP_WALL *wal, *wal2;
	XBUILD_MAP_SPRITE *spr;
	XBUILD_MAP_SECTOR *sec, *sec2;
	long i, j, templong1, templong2;
	long oxvect, oyvect, goalx, goaly, intx, inty, lx, ly, retval;
	long k, l, clipsectcnt, startwall, endwall, cstat, dasect;
	long x1, y1, x2, y2, cx, cy, rad, xmin, ymin, xmax, ymax, daz, daz2;
	long bsz, dax, day, xoff, yoff, xspan, yspan, cosang, sinang, tilenum;
	long xrepeat, yrepeat, gx, gy, dx, dy, dasprclipmask, dawalclipmask;
	long hitwall, cnt, clipyou;
	unsigned short tcx, tcy;
	if (((xvect|yvect) == 0) || (*sectnum < 0)) return(0);
	retval = 0;

	oxvect = xvect;
	oyvect = yvect;

	goalx = (*x) + (xvect>>14);
	goaly = (*y) + (yvect>>14);


	clipnum = 0;

	cx = (((*x)+goalx)>>1);
	cy = (((*y)+goaly)>>1);
		//Extra walldist for sprites on sector lines
	gx = goalx-(*x); gy = goaly-(*y);
	rad = sqrt(gx*gx + gy*gy) + MAXCLIPDIST+walldist + 8;
	xmin = cx-rad; ymin = cy-rad;
	xmax = cx+rad; ymax = cy+rad;

	dawalclipmask = (cliptype&65535);        //CLIPMASK0 = 0x00010001
	dasprclipmask = (cliptype>>16);          //CLIPMASK1 = 0x01000040

	ANIMATE_ClipSectorList[0] = (*sectnum);
	clipsectcnt = 0; clipsectnum = 1;
	do
	{
		dasect = ANIMATE_ClipSectorList[clipsectcnt++];
		sec = &ANIMATE_pMap->Sector[dasect];
		startwall = sec->WallPointer; endwall = startwall + sec->WallNumber;
		for(j=startwall,wal=&ANIMATE_pMap->Wall[startwall];j<endwall;j++,wal++)
		{
			wal2 = &ANIMATE_pMap->Wall[wal->Point2];
			if ((wal->X < xmin) && (wal2->X < xmin)) continue;
			if ((wal->X > xmax) && (wal2->X > xmax)) continue;
			if ((wal->Y < ymin) && (wal2->Y < ymin)) continue;
			if ((wal->Y > ymax) && (wal2->Y > ymax)) continue;

			x1 = wal->X; y1 = wal->Y; x2 = wal2->X; y2 = wal2->Y;

			dx = x2-x1; dy = y2-y1;
			if (dx*((*y)-y1) < ((*x)-x1)*dy) continue;  //If wall's not facing you

			if (dx > 0) dax = dx*(ymin-y1); else dax = dx*(ymax-y1);
			if (dy > 0) day = dy*(xmax-x1); else day = dy*(xmin-x1);
			if (dax >= day) continue;

			clipyou = 0;
			if ((wal->NextSector < 0) || (wal->CStat&dawalclipmask)) clipyou = 1;
			else if (editstatus == 0)
			{
				if (rintersect(*x,*y,0,gx,gy,0,x1,y1,x2,y2,&dax,&day,&daz) == 0)
				{				
					dax = *x, day = *y;
				}
				daz = XBUILD_ANIMATE_GetFloorHeight((short)dasect,dax,day) << 4;
				daz2 = XBUILD_ANIMATE_GetFloorHeight(wal->NextSector,dax,day) << 4;

				sec2 = &ANIMATE_pMap->Sector[wal->NextSector];
				if (daz2 < daz-(1<<8))
					if ((sec2->FStat&1) == 0)
						if ((*z) >= daz2-(flordist-1)) clipyou = 1;
				if (clipyou == 0)
				{
					daz = XBUILD_ANIMATE_GetCeilingHeight((short)dasect,dax,day) << 4;
					daz2 = XBUILD_ANIMATE_GetCeilingHeight(wal->NextSector,dax,day) << 4;
					if (daz2 > daz+(1<<8))
						if ((sec2->CStat&1) == 0)
							if ((*z) <= daz2+(ceildist-1)) clipyou = 1;
				}
			}

			if (clipyou)
			{
					//Add 2 boxes at endpoints
				bsz = walldist; if (gx < 0) bsz = -bsz;
				addclipline(x1-bsz,y1-bsz,x1-bsz,y1+bsz,(short)j+32768);
				addclipline(x2-bsz,y2-bsz,x2-bsz,y2+bsz,(short)j+32768);
				bsz = walldist; if (gy < 0) bsz = -bsz;
				addclipline(x1+bsz,y1-bsz,x1-bsz,y1-bsz,(short)j+32768);
				addclipline(x2+bsz,y2-bsz,x2-bsz,y2-bsz,(short)j+32768);

				dax = walldist; if (dy > 0) dax = -dax;
				day = walldist; if (dx < 0) day = -day;
				addclipline(x1+dax,y1+day,x2+dax,y2+day,(short)j+32768);
			}
			else
			{
				for(i=clipsectnum-1;i>=0;i--)
					if (wal->NextSector == ANIMATE_ClipSectorList[i]) break;
				if (i < 0) ANIMATE_ClipSectorList[clipsectnum++] = wal->NextSector;
			}
		}

		for(j=headspritesect[dasect];j>=0;j=nextspritesect[j])
		{
			spr = &ANIMATE_pMap->Sprite[j];
			XBUILD_ART_GetTileDimensions(spr->Pic, &tcx, &tcy);
			cstat = spr->CStat;
			if ((cstat&dasprclipmask) == 0) continue;
			x1 = spr->X; y1 = spr->Y;
			switch(cstat&48)
			{
				case 0:
					if ((x1 >= xmin) && (x1 <= xmax) && (y1 >= ymin) && (y1 <= ymax))
					{
						k = ((tcy*spr->RepY)<<2);
						if (cstat&128) daz = spr->Z+(k>>1); else daz = spr->Z;
						//TODO: Add support for this (Tile center position)
						//if (picanm[spr->picnum]&0x00ff0000) daz -= ((long)((signed char)((picanm[spr->picnum]>>16)&255))*spr->yrepeat<<2);
						if (((*z) < daz+ceildist) && ((*z) > daz-k-flordist))
						{
							bsz = (spr->Clipdist<<2)+walldist; if (gx < 0) bsz = -bsz;
							addclipline(x1-bsz,y1-bsz,x1-bsz,y1+bsz,(short)j+49152);
							bsz = (spr->Clipdist<<2)+walldist; if (gy < 0) bsz = -bsz;
							addclipline(x1+bsz,y1-bsz,x1-bsz,y1-bsz,(short)j+49152);
						}
					}
					break;
				case 16:
					k = ((tcy*spr->RepY)<<2);
					if (cstat&128) daz = spr->Z+(k>>1); else daz = spr->Z;
					//TODO: Add support for this (Tile center position)
					//if (picanm[spr->picnum]&0x00ff0000) daz -= ((long)((signed char)((picanm[spr->picnum]>>16)&255))*spr->yrepeat<<2);
					daz2 = daz-k;
					daz += ceildist; daz2 -= flordist;
					if (((*z) < daz) && ((*z) > daz2))
					{
							//These lines get the 2 points of the rotated sprite
							//Given: (x1, y1) starts out as the center point
						tilenum = spr->Pic;
						//TODO: Add support for this (Tile center position)
						//xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
						//Modified line
						xoff = ((long)spr->OffX);
						if ((cstat&4) > 0) xoff = -xoff;
						k = spr->Angle; l = spr->RepX;
						dax = ANIMATE_SinTable[k&2047]*l; day = ANIMATE_SinTable[(k+1536)&2047]*l;
						l = tcx; k = (l>>1)+xoff;
						x1 -= mulscale16(dax,k); x2 = x1+mulscale16(dax,l);
						y1 -= mulscale16(day,k); y2 = y1+mulscale16(day,l);
						if (clipinsideboxline(cx,cy,x1,y1,x2,y2,rad) != 0)
						{
							dax = mulscale14(ANIMATE_SinTable[(spr->Angle+256+512)&2047],walldist);
							day = mulscale14(ANIMATE_SinTable[(spr->Angle+256)&2047],walldist);

							if ((x1-(*x))*(y2-(*y)) >= (x2-(*x))*(y1-(*y)))   //Front
							{
								addclipline(x1+dax,y1+day,x2+day,y2-dax,(short)j+49152);
							}
							else
							{
								if ((cstat&64) != 0) continue;
								addclipline(x2-dax,y2-day,x1-day,y1+dax,(short)j+49152);
							}

								//Side blocker
							if ((x2-x1)*((*x)-x1) + (y2-y1)*((*y)-y1) < 0)
								{ addclipline(x1-day,y1+dax,x1+dax,y1+day,(short)j+49152); }
							else if ((x1-x2)*((*x)-x2) + (y1-y2)*((*y)-y2) < 0)
								{ addclipline(x2+day,y2-dax,x2-dax,y2-day,(short)j+49152); }
						}
					}
					break;
				case 32:
					daz = spr->Z+ceildist;
					daz2 = spr->Z-flordist;
					if (((*z) < daz) && ((*z) > daz2))
					{
						if ((cstat&64) != 0)
							if (((*z) > spr->Z) == ((cstat&8)==0)) continue;

						tilenum = spr->Pic;
						//TODO: Add support for this (Tile center position)
						//xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
						//yoff = (long)((signed char)((picanm[tilenum]>>16)&255))+((long)spr->yoffset);
						//Modified lines
						xoff = ((long)spr->OffX);
						yoff = ((long)spr->OffY);

						if ((cstat&4) > 0) xoff = -xoff;
						if ((cstat&8) > 0) yoff = -yoff;

						k = spr->Angle;
						cosang = ANIMATE_SinTable[(k+512)&2047]; sinang = ANIMATE_SinTable[k];
						xspan = tcx; xrepeat = spr->RepX;
						yspan = tcy; yrepeat = spr->RepY;

						dax = ((xspan>>1)+xoff)*xrepeat; day = ((yspan>>1)+yoff)*yrepeat;
						rxi[0] = x1 + dmulscale16(sinang,dax,cosang,day);
						ryi[0] = y1 + dmulscale16(sinang,day,-cosang,dax);
						l = xspan*xrepeat;
						rxi[1] = rxi[0] - mulscale16(sinang,l);
						ryi[1] = ryi[0] + mulscale16(cosang,l);
						l = yspan*yrepeat;
						k = -mulscale16(cosang,l); rxi[2] = rxi[1]+k; rxi[3] = rxi[0]+k;
						k = -mulscale16(sinang,l); ryi[2] = ryi[1]+k; ryi[3] = ryi[0]+k;

						dax = mulscale14(ANIMATE_SinTable[(spr->ang-256+512)&2047],walldist);
						day = mulscale14(ANIMATE_SinTable[(spr->ang-256)&2047],walldist);

						if ((rxi[0]-(*x))*(ryi[1]-(*y)) < (rxi[1]-(*x))*(ryi[0]-(*y)))
						{
							if (clipinsideboxline(cx,cy,rxi[1],ryi[1],rxi[0],ryi[0],rad) != 0)
								addclipline(rxi[1]-day,ryi[1]+dax,rxi[0]+dax,ryi[0]+day,(short)j+49152);
						}
						else if ((rxi[2]-(*x))*(ryi[3]-(*y)) < (rxi[3]-(*x))*(ryi[2]-(*y)))
						{
							if (clipinsideboxline(cx,cy,rxi[3],ryi[3],rxi[2],ryi[2],rad) != 0)
								addclipline(rxi[3]+day,ryi[3]-dax,rxi[2]-dax,ryi[2]-day,(short)j+49152);
						}

						if ((rxi[1]-(*x))*(ryi[2]-(*y)) < (rxi[2]-(*x))*(ryi[1]-(*y)))
						{
							if (clipinsideboxline(cx,cy,rxi[2],ryi[2],rxi[1],ryi[1],rad) != 0)
								addclipline(rxi[2]-dax,ryi[2]-day,rxi[1]-day,ryi[1]+dax,(short)j+49152);
						}
						else if ((rxi[3]-(*x))*(ryi[0]-(*y)) < (rxi[0]-(*x))*(ryi[3]-(*y)))
						{
							if (clipinsideboxline(cx,cy,rxi[0],ryi[0],rxi[3],ryi[3],rad) != 0)
								addclipline(rxi[0]+dax,ryi[0]+day,rxi[3]+day,ryi[3]-dax,(short)j+49152);
						}
					}
					break;
			}
		}
	} while (clipsectcnt < clipsectnum);


	hitwall = 0;
	cnt = clipmoveboxtracenum;
	do
	{
		intx = goalx; inty = goaly;
		if ((hitwall = raytrace(*x, *y, &intx, &inty)) >= 0)
		{
			lx = clipit[hitwall].x2-clipit[hitwall].x1;
			ly = clipit[hitwall].y2-clipit[hitwall].y1;
			templong2 = lx*lx + ly*ly;
			if (templong2 > 0)
			{
				templong1 = (goalx-intx)*lx + (goaly-inty)*ly;

				if ((klabs(templong1)>>11) < templong2)
					i = divscale20(templong1,templong2);
				else
					i = 0;
				goalx = mulscale20(lx,i)+intx;
				goaly = mulscale20(ly,i)+inty;
			}

			templong1 = dmulscale6(lx,oxvect,ly,oyvect);
			for(i=cnt+1;i<=clipmoveboxtracenum;i++)
			{
				j = hitwalls[i];
				templong2 = dmulscale6(clipit[j].x2-clipit[j].x1,oxvect,clipit[j].y2-clipit[j].y1,oyvect);
				if ((templong1^templong2) < 0)
				{
					XBUILD_ANIMATE_UpdateSector(*x,*y,(int*)sectnum);
					return(retval);
				}
			}

			keepaway(&goalx, &goaly, hitwall);
			xvect = ((goalx-intx)<<14);
			yvect = ((goaly-inty)<<14);

			if (cnt == clipmoveboxtracenum) retval = clipobjectval[hitwall];
			hitwalls[cnt] = hitwall;
		}
		cnt--;

		*x = intx;
		*y = inty;
	} while (((xvect|yvect) != 0) && (hitwall >= 0) && (cnt > 0));

	for(j=0;j<clipsectnum;j++)
		if (ANIMATE_Inside(*x,*y,ANIMATE_ClipSectorList[j]) == 1)
		{
			*sectnum = ANIMATE_ClipSectorList[j];
			return(retval);
		}

	*sectnum = -1; templong1 = 0x7fffffff;
	for(j=ANIMATE_pMap->Mapinfo.SectorNumber-1;j>=0;j--)
		if (ANIMATE_Inside(*x,*y,j) == 1)
		{
			if (ANIMATE_pMap->Sector[j].CStat&2)
				templong2 = ((XBUILD_ANIMATE_GetCeilingHeight((short)j,*x,*y))-(*z));
			else
				templong2 = ((ANIMATE_pMap->Sector[j].CZ << 4)-(*z));

			if (templong2 > 0)
			{
				if (templong2 < templong1)
					{ *sectnum = j; templong1 = templong2; }
			}
			else
			{
				if (ANIMATE_pMap->Sector[j].FStat&2)
					templong2 = ((*z)-(XBUILD_ANIMATE_GetFloorHeight((short)j,*x,*y)));
				else
					templong2 = ((*z)-(ANIMATE_pMap->Sector[j].FZ << 4));

				if (templong2 <= 0)
				{
					*sectnum = j;
					return(retval);
				}
				if (templong2 < templong1)
					{ *sectnum = j; templong1 = templong2; }
			}
		}
	return(retval);
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_CanSee(long x1, long y1, long z1, short sect1, long x2, long y2, long z2, short sect2)
{
	XBUILD_MAP_SECTOR *sec;
	XBUILD_MAP_WALL *wal, *wal2;
	long i, cnt, nexts, x, y, z, cz, fz, dasectnum, dacnt, danum;
	long x21, y21, z21, x31, y31, x34, y34, bot, t;

	if ((x1 == x2) && (y1 == y2)) return(sect1 == sect2);

	x21 = x2-x1; y21 = y2-y1; z21 = z2-z1;

	ANIMATE_ClipSectorList[0] = sect1; danum = 1;
	for(dacnt=0;dacnt<danum;dacnt++)
	{
		dasectnum = ANIMATE_ClipSectorList[dacnt]; sec = &ANIMATE_pMap->Sector[dasectnum];
		for(cnt=sec->WallNumber,wal=&ANIMATE_pMap->Wall[sec->WallPointer];cnt>0;cnt--,wal++)
		{
			wal2 = &ANIMATE_pMap->Wall[wal->Point2];
			x31 = wal->X-x1; x34 = wal->X-wal2->X;
			y31 = wal->Y-y1; y34 = wal->Y-wal2->Y;

			bot = y21*x34-x21*y34; if (bot <= 0) continue;
			t = y21*x31-x21*y31; if ((unsigned)t >= (unsigned)bot) continue;
			t = y31*x34-x31*y34; if ((unsigned)t >= (unsigned)bot) continue;

			nexts = wal->NextSector;
			if ((nexts < 0) || (wal->CStat&32)) return(0);

			t = divscale24(t,bot);
			x = x1 + mulscale24(x21,t);
			y = y1 + mulscale24(y21,t);
			z = z1 + mulscale24(z21,t);

			cz = XBUILD_ANIMATE_GetCeilingHeight(dasectnum, x, y);
			fz = XBUILD_ANIMATE_GetFloorHeight(dasectnum, x, y);
			//getzsofslope((short)dasectnum,x,y,&cz,&fz);
			if ((z <= cz) || (z >= fz)) return(0);
			cz = XBUILD_ANIMATE_GetCeilingHeight(nexts, x, y);
			fz = XBUILD_ANIMATE_GetFloorHeight(nexts, x, y);
			//getzsofslope((short)nexts,x,y,&cz,&fz);
			if ((z <= cz) || (z >= fz)) return(0);

			for(i=danum-1;i>=0;i--) if (ANIMATE_ClipSectorList[i] == nexts) break;
			if (i < 0) ANIMATE_ClipSectorList[danum++] = nexts;
		}
	}
	for(i=danum-1;i>=0;i--) if (ANIMATE_ClipSectorList[i] == sect2) return(1);
	return(0);
}

extern "C" void DLLEXPORT XBUILD_ANIMATE_RotatePoint(long xpivot, long ypivot, long x, long y, short daang, long *x2, long *y2)
{
	long dacos, dasin;

	dacos = ANIMATE_SinTable[(daang+2560)&2047];
	dasin = ANIMATE_SinTable[(daang+2048)&2047];
	x -= xpivot;
	y -= ypivot;
	*x2 = dmulscale14(x,dacos,-y,dasin) + xpivot;
	*y2 = dmulscale14(y,dacos,x,dasin) + ypivot;
}

extern "C" int DLLEXPORT XBUILD_ANIMATE_NextSectorNeighborZ(short sectnum, long thez, short topbottom, short direction)
{
	XBUILD_MAP_WALL *wal;
	long i, testz, nextz;
	short sectortouse;

	if (direction == 1) nextz = 0x7fffffff; else nextz = 0x80000000;

	sectortouse = -1;

	wal = &ANIMATE_pMap->Wall[ANIMATE_pMap->Sector[sectnum].WallPointer];
	i = ANIMATE_pMap->Sector[sectnum].WallNumber;
	do
	{
		if (wal->NextSector >= 0)
		{
			if (topbottom == 1)
			{
				testz = ANIMATE_pMap->Sector[wal->NextSector].FZ;
				if (direction == 1)
				{
					if ((testz > thez) && (testz < nextz))
					{
						nextz = testz;
						sectortouse = wal->NextSector;
					}
				}
				else
				{
					if ((testz < thez) && (testz > nextz))
					{
						nextz = testz;
						sectortouse = wal->NextSector;
					}
				}
			}
			else
			{
				testz = ANIMATE_pMap->Sector[wal->NextSector].CZ;
				if (direction == 1)
				{
					if ((testz > thez) && (testz < nextz))
					{
						nextz = testz;
						sectortouse = wal->NextSector;
					}
				}
				else
				{
					if ((testz < thez) && (testz > nextz))
					{
						nextz = testz;
						sectortouse = wal->NextSector;
					}
				}
			}
		}
		wal++;
		i--;
	} while (i != 0);

	return(sectortouse);
}
