#include "COMMON.H"

extern HWND					GFX_hWnd;
int							MUSIC_nPlaying;
MCI_OPEN_PARMS				MUSIC_MCIOpen = { NULL, NULL, "SEQUENCER", "DN3DMUS.MID", NULL };
MCI_OPEN_PARMS				MUSIC_CDOpen = { NULL, NULL, "CDAUDIO", NULL, NULL };
WORD						MUSIC_dwMCIDevice = 0;
IDirectMusicLoader*			MUSIC_lpDMUSLoader;
IDirectMusicPerformance*	MUSIC_lpDMUSPerf;
IDirectMusicSegment*		MUSIC_lpDMUSSegment;
IDirectMusicSegmentState*	MUSIC_lpDMUSSegmentState;
extern LPDIRECTSOUND		SOUND_lpDS;
int							MUSIC_nMusicDriver = 0;

void MUSIC_CDStop()
{
	MCI_GENERIC_PARMS g;
	MUSIC_nPlaying = 0;
	if(MUSIC_dwMCIDevice)
	{
		g.dwCallback = NULL;
		mciSendCommand(MUSIC_dwMCIDevice, MCI_STOP, MCI_NOTIFY, (unsigned long)&g); 
		mciSendCommand(MUSIC_dwMCIDevice, MCI_CLOSE, MCI_NOTIFY, (unsigned long)&g);
	}
}

void MUSIC_CDPlay()
{
	MCI_PLAY_PARMS p;
	if(MUSIC_nPlaying)
	{
		MUSIC_CDStop();
	}
	MUSIC_CDOpen.dwCallback = (unsigned long)GFX_hWnd;
	mciSendCommand(NULL, MCI_OPEN, MCI_OPEN_TYPE, (unsigned long)&MUSIC_CDOpen); 
	MUSIC_dwMCIDevice = MUSIC_CDOpen.wDeviceID;
	p.dwCallback = (unsigned long)GFX_hWnd;
	mciSendCommand(MUSIC_dwMCIDevice, MCI_PLAY, MCI_NOTIFY, (unsigned long)&p); 
	MUSIC_nPlaying = 1;
}

void MUSIC_MCIStop()
{
	MCI_GENERIC_PARMS g;
	MUSIC_nPlaying = 0;
	if(MUSIC_dwMCIDevice)
	{
		g.dwCallback = NULL;
		mciSendCommand(MUSIC_dwMCIDevice, MCI_STOP, MCI_NOTIFY, (unsigned long)&g); 
		mciSendCommand(MUSIC_dwMCIDevice, MCI_CLOSE, MCI_NOTIFY, (unsigned long)&g);
	}
}

void MUSIC_MCIPlay()
{
	MCI_PLAY_PARMS p;
	if(MUSIC_nPlaying)
	{
		MUSIC_MCIStop();
	}
	MUSIC_MCIOpen.dwCallback = (unsigned long)GFX_hWnd;
	mciSendCommand(NULL, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (unsigned long)&MUSIC_MCIOpen); 
	MUSIC_dwMCIDevice = MUSIC_MCIOpen.wDeviceID;
	p.dwCallback = (unsigned long)GFX_hWnd;
	mciSendCommand(MUSIC_dwMCIDevice, MCI_PLAY, MCI_NOTIFY, (unsigned long)&p); 
	MUSIC_nPlaying = 1;
}


void MUSIC_MCICallback(WPARAM wParam, LPARAM lParam)
{
	if(wParam == MCI_NOTIFY_SUCCESSFUL)
	{
		if(MUSIC_nPlaying && MUSIC_nMusicDriver == XBUILD_MUSIC_DRIVER_MCI)
		{
			MUSIC_MCIPlay();	
		}
	}
}

void MUSIC_DMUSInitialize()
{
	CoInitialize(NULL);
	CoCreateInstance(CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC, IID_IDirectMusicPerformance, (void**)&MUSIC_lpDMUSPerf);
	CoCreateInstance(CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC, IID_IDirectMusicLoader, (void**)&MUSIC_lpDMUSLoader);
	MUSIC_lpDMUSPerf->Init(NULL, SOUND_lpDS, NULL);
	MUSIC_lpDMUSPerf->AddPort(NULL);
}

void MUSIC_DMUSDestroy()
{
	MUSIC_lpDMUSPerf->Release();
	MUSIC_lpDMUSPerf = NULL;
	MUSIC_lpDMUSLoader->Release();
	MUSIC_lpDMUSLoader = NULL;
	CoUninitialize();
}

void MUSIC_DMUSStop()
{
	if(MUSIC_lpDMUSPerf != NULL)
	{
		MUSIC_lpDMUSPerf->Stop(MUSIC_lpDMUSSegment, MUSIC_lpDMUSSegmentState, 0, 0);
		MUSIC_lpDMUSSegmentState->Release();
		MUSIC_lpDMUSSegmentState = NULL;
		MUSIC_lpDMUSSegment->Release();
		MUSIC_lpDMUSSegment = NULL;
		MUSIC_DMUSDestroy();
	}
	MUSIC_DMUSInitialize();
	MUSIC_nPlaying = 0;
}

void MUSIC_DMUSPlay()
{
	DMUS_OBJECTDESC DMOBJ;
	char szDir[_MAX_PATH];
	WCHAR wszDir[_MAX_PATH];
	WCHAR wFilename[255];
	if(MUSIC_nPlaying)
	{
		MUSIC_DMUSStop();
	}
	getcwd(szDir, _MAX_PATH);
	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, szDir, -1, wszDir, _MAX_PATH);
	wcscpy(wFilename, L"DN3DMUS.MID");
	MUSIC_lpDMUSLoader->SetSearchDirectory(GUID_DirectMusicAllTypes, wszDir, FALSE);
	DMOBJ.guidClass = CLSID_DirectMusicSegment;
	DMOBJ.dwSize = sizeof(DMUS_OBJECTDESC);
	wcscpy(DMOBJ.wszFileName, wFilename);
	DMOBJ.dwValidData = DMUS_OBJ_CLASS | DMUS_OBJ_FILENAME;
	MUSIC_lpDMUSLoader->GetObject(&DMOBJ, IID_IDirectMusicSegment2, (void**)&MUSIC_lpDMUSSegment);
	MUSIC_lpDMUSSegment->SetParam(GUID_StandardMIDIFile, -1, 0, 0, (void*)MUSIC_lpDMUSPerf);
	MUSIC_lpDMUSSegment->SetParam(GUID_Download, -1, 0, 0, (void*)MUSIC_lpDMUSPerf);
	MUSIC_lpDMUSSegment->SetRepeats(DMUS_SEG_REPEAT_INFINITE);
	MUSIC_lpDMUSPerf->PlaySegment(MUSIC_lpDMUSSegment, 0, 0, &MUSIC_lpDMUSSegmentState);	
	MUSIC_nPlaying = 1;
}

extern "C" void DLLEXPORT XBUILD_MUSIC_Play(char *lpstrFilename, int nDevice)
{
	MUSIC_nMusicDriver = nDevice;
	switch(nDevice)
	{
	case XBUILD_MUSIC_DRIVER_MCI:
		MUSIC_MCIStop();
		XBUILD_GRPMANAGER_ExtractFile(lpstrFilename, "DN3DMUS.MID");
		MUSIC_MCIPlay();
		break;
	case XBUILD_MUSIC_DRIVER_DMUS:
		MUSIC_DMUSStop();
		XBUILD_GRPMANAGER_ExtractFile(lpstrFilename, "DN3DMUS.MID");
		MUSIC_DMUSPlay();
		break;
	case XBUILD_MUSIC_DRIVER_CD:
		MUSIC_CDStop();
		MUSIC_CDPlay();
		break;
	}
}

extern "C" void DLLEXPORT XBUILD_MUSIC_Stop()
{
	switch(MUSIC_nMusicDriver)
	{
	case XBUILD_MUSIC_DRIVER_MCI:
		MUSIC_MCIStop();
		break;
	case XBUILD_MUSIC_DRIVER_DMUS:
		MUSIC_DMUSStop();
		break;
	case XBUILD_MUSIC_DRIVER_CD:
		MUSIC_CDStop();
		break;
	}
}
