#include "COMMON.H"

#define REMOSTRT	"REMOSTRT"
#define REMOSTOP	"REMOSTOP"

struct WADHEADER
{
	char			strSignature[4];
	unsigned long	dwFileTableEntryCount;
	unsigned long	dwFileTablePos;
};

struct WADFILETABLEENTRY
{
	unsigned long	dwFilePos;
	unsigned long	dwFileSize;
	char			strFileName[8];
};

char*				RTSMANAGER_lpstrRTSFile;
WADFILETABLEENTRY*	RTSMANAGER_pEntries;
int					RTSMANAGER_nFilecount = 0;

int RTSMANAGER_SetMainFile(char *lpstrFile)
{
	FILE *stream;
	WADHEADER w;
	RTSMANAGER_lpstrRTSFile = lpstrFile;
	stream = fopen(lpstrFile, "rb");
	if(!stream)
	{
		msgboxf(NULL, TITLE, 16, "Couldn't open '%s' for reading.\nPlease put '%s' in this game directory.", lpstrFile, lpstrFile);
		return 0;
	}
	fread(&w, sizeof(WADHEADER), 1, stream);
	if(strncmp(w.strSignature, "IWAD", 4))
	{
		msgboxf(NULL, TITLE, 16, "The file '%s' is an invalid RTS file.\n(IWAD signature not found)", lpstrFile);
		return 0;
	}
	fseek(stream, w.dwFileTablePos, SEEK_SET);
	//Remove the first and the last entry in the count
	RTSMANAGER_nFilecount = w.dwFileTableEntryCount - 2;
	RTSMANAGER_pEntries = new WADFILETABLEENTRY[RTSMANAGER_nFilecount];
	fseek(stream, w.dwFileTablePos, SEEK_SET);
	//Let's skip the first entry
	fseek(stream, sizeof(WADFILETABLEENTRY), SEEK_CUR);
	fread(RTSMANAGER_pEntries, sizeof(WADFILETABLEENTRY) * RTSMANAGER_nFilecount, 1, stream);
	fclose(stream);
	XBUILD_CONSOLE_PrintFormatted("Setting main RTS file for '%s'.\r\n", lpstrFile);
	return 1;
}

extern "C" void DLLEXPORT XBUILD_RTSMANAGER_Play(int nSound)
{
	FILE *stream;
	unsigned _int8 *lpBuffer;
	lpBuffer = new unsigned _int8[RTSMANAGER_pEntries[nSound].dwFileSize];
	stream = fopen(RTSMANAGER_lpstrRTSFile, "rb");
	fseek(stream, RTSMANAGER_pEntries[nSound].dwFilePos, SEEK_SET);
	fread(lpBuffer, RTSMANAGER_pEntries[nSound].dwFileSize, 1, stream);
	fclose(stream);
	XBUILD_SOUND_PlayEx(lpBuffer, RTSMANAGER_pEntries[nSound].dwFileSize, 0);
}